<template>
  <lazy-theme-desktop-china-components-promotion-banner
    height="460px"
  ></lazy-theme-desktop-china-components-promotion-banner>
  <div class="mb-10 w-[1200px] mx-auto mt-6">
    <div class="relative mt-5">
      <lazy-promotion-type :menu="'left'">
        <template #left-side>
          <div class="flex justify-center">
            <div class="text-center trapezoid" :class="{'custom-border-bottom' : needCustomBorderBottom}">
              <span class="text-white font-bold mt-3 text-[16px]">{{
                $t("promotion_type")
              }}</span>
            </div>
          </div>
          <div
            class="py-2 overflow-y-auto rounded-lg bg-gray-50 drop-shadow-xl"
          >
            <div class="my-5 promotion-tab">
              <el-radio-group v-model="selectedType">
                <el-radio
                  v-for="(promoGroup, index) in promotionGroup"
                  :key="index"
                  :label="promoGroup.label"
                  size="large"
                >
                  <div class="promotion-type">
                    <div class="px-4 py-3 text-base font-normal cursor-pointer">
                      <div class="flex items-center">
                        <div
                          class="promotion-icon"
                          :class="promoGroup.class"
                        ></div>
                        <span class="ml-3 text-promotion">{{
                          promoGroup.Type
                        }}</span>
                      </div>
                    </div>
                  </div>
                </el-radio>
              </el-radio-group>
            </div>
          </div>
        </template>
        <template #right-side>
          <div class="flex flex-col gap-7">
            <lazy-promotion-horizontal-card
              v-for="promotion in promotionListForDisplay"
              :key="promotion.Id"
              :authenticated="authenticated"
              :promotion="promotion"
              :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
              :check-promotion-group="checkPromotionGroup"
              :on-apply-promotion="onApplyPromotion"
              :is-processing="isProcessing"
              :is-applying="applyRequest.PromotionId === promotion.Id"
              style="--promotion-dialog-content-color: var(--primary)"
              :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
              :on-click-spin-now="onClickSpinNow"
            />
            <div
              v-if="promotionListForDisplay.length === 0"
              class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
            >
              <div class="text-4xl text-center truncate no-data text-ellipsis">
                {{ $t("no_promotion_info") }}
              </div>
              <span class="font-bold text-lg fc-text">{{
                assignHashText
              }}</span>
            </div>
          </div>
        </template>
      </lazy-promotion-type>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import { IPromotion } from "@/models/promotion/promotion";
import { store } from "@/store";

export default defineComponent({
  name: "Promotion",
  setup() {
    const visible = ref(false);
    const selectedPromotion = ref<IPromotion>();
    const toggleDialog = (promotion: IPromotion) => {
      visible.value = true;
      selectedPromotion.value = promotion;
    };
    const { $t } = useNuxtApp();
    const checkTypeClass = (type: string) => {
      if (type === $t("common")) {
        return "promotion-type-title-common";
      }
      if (type === $t("first_deposit")) {
        return "promotion-type-title-first-deposit";
      }
      return "promotion-type-title-rebate";
    };
    const checkTriangleClass = (type: string) => {
      if (type === $t("common")) {
        return "curved-corner-topleft-common";
      }
      if (type === $t("first_deposit")) {
        return "curved-corner-topleft-first-deposit";
      }
      return "curved-corner-topleft-rebate";
    };
    const checkIconClass = (type: string) => {
      if (type === $t("common")) {
        return "common_icon";
      }
      if (type === $t("first_deposit")) {
        return "first-deposit_icon";
      }
      return "rebate_icon";
    };
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      checkPromotionGroup,
      promotionGroup,
      selectedType,
      promotionListForDisplay,
      assignHashText,
      applyRequest,
      validateLuckyWheelbutton,
      onClickSpinNow,
    } = usePromotion();
    const { getAssetImage } = commonHelper;
    const activeBoxIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/box_active.png"
    )})`;
    const activeClockIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/clock_active.png"
    )})`;
    const activeCalendarIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/calendar_active.png"
    )})`;
    const activeChatIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/chat_active.png"
    )})`;
    const messageIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/Massage.png"
    )})`;
    const dateIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/Date.png"
    )})`;
    const boxIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/box.png"
    )})`;
    const rebateIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/rebate.png"
    )})`;
    const commonIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/common.png"
    )})`;
    const firstDepositIcon = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/promotion/first_deposit.png"
    )})`;
    const needCustomBorderBottom = computed(() => ['pt_BR', 'es_ES'].includes(store.state.locale));
    return {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      selectedType,
      checkPromotionGroup,
      visible,
      toggleDialog,
      selectedPromotion,
      promotionGroup,
      checkTypeClass,
      checkTriangleClass,
      checkIconClass,
      promotionListForDisplay,
      activeBoxIcon,
      activeClockIcon,
      activeCalendarIcon,
      activeChatIcon,
      messageIcon,
      dateIcon,
      boxIcon,
      rebateIcon,
      commonIcon,
      firstDepositIcon,
      assignHashText,
      applyRequest,
      needCustomBorderBottom,
      validateLuckyWheelbutton,
      onClickSpinNow,
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(.el-button.el-button--primary, .el-button.el-button--danger.is-plain) {
  width: 140px;
}

:deep(.el-button.el-button--primary) {
  background: linear-gradient(
      277.16deg,
      rgba(0, 0, 0, 0.4) 6.37%,
      rgba(0, 0, 0, 0) 94.08%
    ),
    #4176fa;
}

:deep(.promotion-header .el-dialog__header) {
  word-break: break-all;
  margin-right: 0;
  padding: 0;
}

:deep(.promotion-header.el-dialog) {
  border-radius: 9px;
}

:deep(.promotion-header .el-dialog__body) {
  padding: 0;
  max-height: 150vw;
}

.body-text {
  color: var(--primary);
  font-size: 14px;
}

.border-top-dialog {
  margin-top: 16px;
  border-top: 4px solid #fbb412;
}

.promotion-date {
  font-weight: 700;
  font-size: 16px;
  line-height: 19px;
  letter-spacing: 0.02em;
  color: var(--primary);
}

.promo-title {
  font-weight: 700;
  font-size: 24px;
  line-height: 28px;
  letter-spacing: 0.02em;
  color: var(--text);
}

.promo-remark {
  font-weight: 700;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: 0.04em;
  color: var(--primary);
}

.promotion-type-title {
  width: 180px;
  height: 40px;
  border-top-left-radius: 9px;
}

.promotion-type-title-common {
  background-image: linear-gradient(to right, rgb(236 151 18), rgb(249 196 77));
}

.promotion-type-title-rebate {
  background-image: linear-gradient(to right, rgb(236 151 18), rgb(249 196 77));
}

.promotion-type-title-first-deposit {
  background-image: linear-gradient(to right, rgb(132 220 25), rgb(144 230 58));
}

.promotion-type-title-dialog {
  width: 180px;
  height: 48px;
  border-top-left-radius: 9px;
}

.promotion_title {
  background-size: contain !important;
  width: 25px;
  height: 25px;
}

.first-deposit_icon {
  background: v-bind("messageIcon");
  background-size: auto;
}

.common_icon {
  background: v-bind("dateIcon");
  background-size: auto;
}

.rebate_icon {
  background: v-bind("dateIcon");
  background-size: auto;
}

#curved-corner-topleft {
  width: 44px;
  height: 40px;
  overflow: hidden;
  position: absolute;
  left: 180px;
  border-style: solid;
  border-width: 40px 44px 0 0;
}

.curved-corner-topleft-common {
  border-color: #f9c44d transparent transparent;
}

.curved-corner-topleft-first-deposit {
  border-color: #90e63a transparent transparent;
}

.curved-corner-topleft-rebate {
  border-color: #f9c44d transparent transparent;
}

#curved-corner-topleft-dialog {
  width: 44px;
  height: 48px;
  overflow: hidden;
  position: absolute;
  left: 180px;
  border-style: solid;
  border-width: 48px 44px 0 0;
}

.sport-entry-play-button {
  border-radius: 24px;
  background: linear-gradient(
      277.16deg,
      rgba(0, 0, 0, 0.4) 6.37%,
      rgba(0, 0, 0, 0) 94.08%
    ),
    #4176fa;
  background-size: contain;
  width: 140px;
  height: 39px;
  color: #fff;
  cursor: pointer;
  transition: 0.3s ease-in-out;
  font-size: 16px;
}

:deep(.el-radio__label) {
  padding-left: 0;
  width: 100%;
}

:deep(.el-radio__input) {
  display: none;
}

:deep(.el-radio) {
  @apply my-2;
  margin-right: 0;
}

.trapezoid {
  border-left: 20px solid transparent;
  border-right: 20px solid transparent;
  border-bottom: 32px solid #409cff;
  width: 160px;
  height: 0px;
}
.custom-border-bottom {
  border-bottom: 50px solid #409cff;
}
.promotion-type:hover {
  background-image: linear-gradient(to right, #007afa, #62b3ff);
  color: #fff;
}

:deep(.el-radio__input.is-checked + .el-radio__label) {
  background-image: linear-gradient(to right, #007afa, #62b3ff);
  color: #fff;
}

:deep(.el-radio.is-checked .el-radio__label .promotion-type .all) {
  background: v-bind("activeBoxIcon");
  background-size: auto;
}

:deep(.el-radio.is-checked .el-radio__label .promotion-type .rebate) {
  background: v-bind("activeClockIcon");
  background-size: auto;
}

:deep(.el-radio.is-checked .el-radio__label .promotion-type .common) {
  background: v-bind("activeCalendarIcon");
  background-size: auto;
}

:deep(.el-radio.is-checked .el-radio__label .promotion-type .first_deposit) {
  background: v-bind("activeChatIcon");
  background-size: auto;
}

.promotion-type:hover .all {
  background: v-bind("activeBoxIcon");
  background-size: auto;
}

.text-promotion {
  font-size: 16px;
}

.all {
  background: v-bind("boxIcon");
  background-size: auto;
}

.promotion-icon {
  background-size: contain !important;
  width: 32px;
  height: 32px;
}

.promotion-type:hover .rebate {
  background: v-bind("activeClockIcon");
  background-size: auto;
}

.rebate {
  background: v-bind("rebateIcon");
}

.promotion-type:hover .common {
  background: v-bind("activeCalendarIcon");
  background-size: auto;
}

.common {
  background: v-bind("commonIcon");
}

.promotion-type:hover .first_deposit {
  background: v-bind("activeChatIcon");
  background-size: auto;
}

.first_deposit {
  background: v-bind("firstDepositIcon");
}
</style>
